Subject: bug#58288: 29.0.50; (flyspell-correct-word-before-point) followed by <down> crashes emacs

From: Po Lu <[email-masked]>
Date: Wed, 05 Oct 2022 18:46:48 +0800

Robert Pluim <[email-masked]> writes:

>>>>>> On Wed, 05 Oct 2022 13:06:52 +0300, Eli Zaretskii <[email-masked]> said:
>     >> void
>     >> save_menu_items (void)
>     >> {
>     >> Lisp_Object saved = list4 (menu_items_inuse ? menu_items : Qnil,
>     >> make_fixnum (menu_items_used),
>     >> make_fixnum (menu_items_n_panes),
>     >> make_fixnum (menu_items_submenu_depth));
>     >> record_unwind_protect (restore_menu_items, saved);
>     >> menu_items_inuse = false;
>     >> menu_items = Qnil;
>     >> }
>     >> 
>     >> This fixes it, but it seems a bit dodgy to me, why has no other
>     >> platform ever run into this?
>
>     Eli> How come a menu is in use, but menu_items_inuse is zero?
>
> `menu_items_inuse' is not zero, itʼs false. `menu_items_used' is
> non-zero. I guess something called `unuse_menu_items', and the
> assumption is then that `menu_items' will not be accessed (but then
> why save away `menu_items_used' etc?
>
> menu.c says:
>
>     /* Whether the global vars defined here are already in use.
>        Used to detect cases where we try to re-enter this non-reentrant code.  */
>     bool menu_items_inuse;
>
> so should we be adding "if (menu_items_inuse)" guards everywhere?
>
> Robert

No matter how much I try I cannot reproduce this (or bug#58296) on
GNUstep, and I don't have access to Mac OS anymore.

But after the holidays are over I will be able to test stuff on a Mac
and will look into this.

Thanks.